package net.es.oscars.policy.database;

import java.io.Serializable;

import org.hibernate.Hibernate;

import net.es.oscars.database.HibernateBean;

/**
 * A criterion used to match a Requester to a policy class
 * 
 * @author Andrew Lake (alake@internet2.edu)
 */
public class PolicyClassCriterion  extends HibernateBean implements Serializable{
    /** persistent field */
    private String value;
    
    /** persistent field */
    private PolicyClass policyClass;
    
    /** persistent field */
    private PolicyClassCriterionType type;

    /**
     * @return the value used to match the policy class
     */
    public String getValue() {
        return this.value;
    }

    /**
     * @param value the value used to match the policy class
     */
    public void setValue(String value) {
        this.value = value;
    }

    /**
     * @return the policyClass to which this criteria applies
     */
    public PolicyClass getPolicyClass() {
        return this.policyClass;
    }

    /**
     * @param policyClass the policyClass to which this criteria applies
     */
    public void setPolicyClass(PolicyClass policyClass) {
        this.policyClass = policyClass;
    }

    /**
     * @return the type of criteria
     */
    public PolicyClassCriterionType getType() {
        return this.type;
    }

    /**
     * @param type the type of criteria
     */
    public void setType(PolicyClassCriterionType type) {
        this.type = type;
    }
    
    public boolean equals(Object o) {
        if (this == o) { return true; }
        Class thisClass = Hibernate.getClass(this);
        if (o == null || thisClass != Hibernate.getClass(o)) {
            return false;
        }
        PolicyClassCriterion castOther = (PolicyClassCriterion) o;
        if(!this.type.getName().equals(castOther.getType().getName())){
            return false;
        }
        if(!this.policyClass.getName().equals(castOther.getPolicyClass().getName())){
            return false;
        }
        if(!this.value.equals(castOther.getValue())){
            return false;
        }
        return true;
    }
}
